#ifndef __DOMAIN_H__
#define __DOMAIN_H__


struct vm_setup_info
{
	unsigned long image_addr; /* address where the elf image is stored */
	unsigned long image_len;

	unsigned long v_start; 
	unsigned long v_end;
	unsigned long v_kernstart; /* virtual address where the kernel should be loaded */
	unsigned long v_kernend;
	unsigned long v_kernentry; /* entry point */
};


#if 0

struct hvm_vcpu {
    unsigned long   ioflags;
    struct mmio_op  mmio_op;
    struct vlapic   *vlapic;
    /* For AP startup */
    unsigned long   init_sipi_sipi_state;

    union {
        struct arch_vmx_struct vmx;
        struct arch_svm_struct svm;
    } u;
};

#define ARCH_HVM_IO_WAIT   1       /* Waiting for I/O completion */




#define HVM_PBUF_SIZE   80

struct hvm_domain {
    unsigned long          shared_page_va;
    unsigned int           nr_vcpus;
    unsigned int           apic_enabled;
    unsigned int           pae_enabled;

    struct hvm_virpit      vpit;
    u64                    guest_time;
    struct hvm_virpic      vpic;
    struct hvm_vioapic     vioapic;
    struct hvm_io_handler  io_handler;

    unsigned char          round_info[256];
    spinlock_t             round_robin_lock;
    int                    interrupt_request;

    int                    pbuf_index;
    char                   pbuf[HVM_PBUF_SIZE];
};


struct arch_domain {
    l1_pgentry_t *mm_perdomain_pt;
    l2_pgentry_t *mm_perdomain_l2;
    l3_pgentry_t *mm_perdomain_l3;

    /* Writable pagetables. */
    struct ptwr_info ptwr[2];

    /* I/O-port admin-specified access capabilities. */
    struct rangeset *ioport_caps;

    /* Shadow mode status and controls. */
    struct shadow_ops *ops;
    unsigned int shadow_mode;  /* flags to control shadow table operation */
    unsigned int shadow_nest;  /* Recursive depth of shadow_lock() nesting */

    /* shadow hashtable */
    struct shadow_status *shadow_ht;
    struct shadow_status *shadow_ht_free;
    struct shadow_status *shadow_ht_extras; /* extra allocation units */
    unsigned int shadow_extras_count;

    /* shadow dirty bitmap */
    unsigned long *shadow_dirty_bitmap;
    unsigned int shadow_dirty_bitmap_size;  /* in pages, bit per page */

    /* shadow mode stats */
    unsigned int shadow_page_count;
    unsigned int hl2_page_count;
    unsigned int snapshot_page_count;

    unsigned int shadow_fault_count;
    unsigned int shadow_dirty_count;

    /* full shadow mode */
    struct out_of_sync_entry *out_of_sync; /* list of out-of-sync pages */
    struct out_of_sync_entry *out_of_sync_free;
    struct out_of_sync_entry *out_of_sync_extras;
    unsigned int out_of_sync_extras_count;

    struct list_head free_shadow_frames;

    pagetable_t         phys_table;         /* guest 1:1 pagetable */
    struct hvm_domain   hvm_domain;

    /* Shadow-translated guest: Pseudophys base address of reserved area. */
    unsigned long first_reserved_pfn;
};



/* Per-domain lock can be recursively acquired in fault handlers. */
#define LOCK_BIGLOCK(_d) spin_lock_recursive(&(_d)->big_lock)
#define UNLOCK_BIGLOCK(_d) spin_unlock_recursive(&(_d)->big_lock)






struct domain {
	domid_t          domain_id;
	
//	shared_info_t   *shared_info;     /* shared data area */
	
//	spinlock_t       big_lock;
	
//	spinlock_t       page_alloc_lock; /* protects all the following fields  */
//	struct list_head page_list;       /* linked list, of size tot_pages     */
//	struct list_head xenpage_list;    /* linked list, of size xenheap_pages */
//	unsigned int     tot_pages;       /* number of pages currently possesed */
//	unsigned int     max_pages;       /* maximum value for tot_pages        */
//	unsigned int     xenheap_pages;   /* # pages allocated from Xen heap    */
	
	/* Scheduling. */
//	int              shutdown_code; /* code value from OS (if DOMF_shutdown) */
//	void            *sched_priv;    /* scheduler-specific data */
	
//	struct domain   *next_in_list;
//	struct domain   *next_in_hashbucket;
	
//	struct list_head rangesets;
//	spinlock_t       rangesets_lock;
	
	/* Event channel information. */
//	struct evtchn   *evtchn[NR_EVTCHN_BUCKETS];
//	spinlock_t       evtchn_lock;
	
//	grant_table_t   *grant_table;
	
	/*
	 * Interrupt to event-channel mappings. Updates should be protected by the 
	 * domain's event-channel spinlock. Read accesses can also synchronise on 
	 * the lock, but races don't usually matter.
	 */
// #define NR_PIRQS 256 /* Put this somewhere sane! */
//	u16              pirq_to_evtchn[NR_PIRQS];
//	DECLARE_BITMAP(pirq_mask, NR_PIRQS);
	
	/* I/O capabilities (access to IRQs and memory-mapped I/O). */
//	struct rangeset *iomem_caps;
//	struct rangeset *irq_caps;
	
//	unsigned long    domain_flags;
//	unsigned long    vm_assist;
	
//	atomic_t         refcnt;
	
	struct vcpu vcpu;
	
//	/* Bitmask of CPUs which are holding onto this domain's state. */
//	cpumask_t        domain_dirty_cpumask;
	
	struct arch_domain arch;
	
	/* Control-plane tools handle for this domain. */
//	xen_domain_handle_t handle;
};


#endif /* 0 */


#endif /* __DOMAIN_H__ */
