#ifndef __SVM_H__
#define __SVM_H__


#include "types.h"
#include "vmcb.h"


struct arch_svm_struct {
	struct vmcb_struct	*vmcb;
	void		        *host_save_area;
	u64                 	host_save_pa;
	u64                 vmcb_pa;
	u32                 *iopm;
	u32                 *msrpm;
	u64                 vmexit_tsc; /* tsc read at #VMEXIT. for TSC_OFFSET */
	int                 injecting_event;
	int                 saved_irq_vector;
	u32                 launch_core;
	u32                 asid_core;
	
	unsigned long       flags;      /* VMCB flags */
	unsigned long       cpu_shadow_cr0; /* Guest value for CR0 */
	unsigned long       cpu_shadow_cr4; /* Guest value for CR4 */
	unsigned long       cpu_cr2;
	unsigned long       cpu_cr3;
	unsigned long       cpu_state;
//	struct timer        hlt_timer;  /* hlt ins emulation wakeup timer */
};


extern void __init enable_svm ( struct cpuinfo_x86 *c );


#endif /* __SVM_H__ */
