
#define	hvm_guest(v)	((v)->arch.guest_context.flags & VGCF_HVM_GUEST)

void
update_pagetables(struct vcpu *v) 
{
	struct domain *d = v->domain;
	int paging_enabled;

	if ( hvm_guest(v) ) {
		paging_enabled = svm_paging_enabled ( v );
	} else {
		// HACK ALERT: there's currently no easy way to figure out if a domU
		// has set its arch.guest_table to zero, vs not yet initialized it.
		paging_enabled = !!pagetable_get_paddr ( v->arch.guest_table );
	}

	/*
	 * We don't call __update_pagetables() when hvm guest paging is
	 * disabled as we want the linear_pg_table to be inaccessible so that
	 * we bail out early of shadow_fault() if the hvm guest tries illegal
	 * accesses while it thinks paging is turned off.
	 */
	if ( paging_enabled ) {
		shadow_lock(d);
		__update_pagetables(v);
		shadow_unlock(d);
	}
}
