#define __ASSEMBLY__

#include "multiboot.h"
#include "msr.h"	
#include "page.h"

	
	.text
        .code32

	.globl	start, _start
start:
_start:
	jmp	physical_entry	/* NOTE: relative addressing */

	.align	4		/* Align 32 bits boundary.  */
	
	/* Multiboot header.  */
multiboot_header:
	.long	MULTIBOOT_HEADER_MAGIC
	.long	MULTIBOOT_HEADER_FLAGS
	.long	-(MULTIBOOT_HEADER_MAGIC + MULTIBOOT_HEADER_FLAGS) /* checksum */
	
die:
        jmp     die

physical_entry:
check:	
        mov     $(PHYS(check_msg)), %esi 
        jmp     print_err	

check_msg:
        .asciz "!!!!!! SAMPLE OPERATING SYSTEM !!!!!!"
print_err:
        mov     $0xB8000,%edi  # VGA framebuffer
1:      mov     (%esi),%bl
        test    %bl,%bl        # Terminate on '\0' sentinel
2:      je      2b
#        mov     $0x3f8+5,%dx   # UART Line Status Register
#3:      in      %dx,%al
#        test    $0x20,%al      # Test THR Empty flag
#        je      3b
#        mov     $0x3f8+0,%dx   # UART Transmit Holding Register
#        mov     %bl,%al
#        out     %al,%dx        # Send a character over the serial line
        movsb                  # Write a character to the VGA framebuffer
        mov     $7,%al
        stosb                  # Write an attribute to the VGA framebuffer
        jmp     1b
